// THIS FILE IS AUTO GENERATED BY GK-CLI DO NOT EDIT!!
package endpoint

import (
	endpoint "github.com/go-kit/kit/endpoint"
	service "license-usage/usage/pkg/service"
)

// Endpoints collects all of the endpoints that compose a profile service. It's
// meant to be used as a helper struct, to collect all of the endpoints into a
// single parameter.
type Endpoints struct {
	KeepAliveUsageEndpoint      endpoint.Endpoint
	CreateKeyUsageInfoEndpoint  endpoint.Endpoint
	UpdateKeyUsageInfoEndpoint  endpoint.Endpoint
	ReadKeyUsageInfoEndpoint    endpoint.Endpoint
	ReadKeyUsageWithMacEndpoint endpoint.Endpoint
	ReadKeyUsageBulkEndpoint    endpoint.Endpoint
	ExpireUsageBulkEndpoint     endpoint.Endpoint
}

// New returns a Endpoints struct that wraps the provided service, and wires in all of the
// expected endpoint middlewares
func New(s service.UsageService, mdw map[string][]endpoint.Middleware) Endpoints {
	eps := Endpoints{
		CreateKeyUsageInfoEndpoint:  MakeCreateKeyUsageInfoEndpoint(s),
		ExpireUsageBulkEndpoint:     MakeExpireUsageBulkEndpoint(s),
		KeepAliveUsageEndpoint:      MakeKeepAliveUsageEndpoint(s),
		ReadKeyUsageBulkEndpoint:    MakeReadKeyUsageBulkEndpoint(s),
		ReadKeyUsageInfoEndpoint:    MakeReadKeyUsageInfoEndpoint(s),
		ReadKeyUsageWithMacEndpoint: MakeReadKeyUsageWithMacEndpoint(s),
		UpdateKeyUsageInfoEndpoint:  MakeUpdateKeyUsageInfoEndpoint(s),
	}
	for _, m := range mdw["KeepAliveUsage"] {
		eps.KeepAliveUsageEndpoint = m(eps.KeepAliveUsageEndpoint)
	}
	for _, m := range mdw["CreateKeyUsageInfo"] {
		eps.CreateKeyUsageInfoEndpoint = m(eps.CreateKeyUsageInfoEndpoint)
	}
	for _, m := range mdw["UpdateKeyUsageInfo"] {
		eps.UpdateKeyUsageInfoEndpoint = m(eps.UpdateKeyUsageInfoEndpoint)
	}
	for _, m := range mdw["ReadKeyUsageInfo"] {
		eps.ReadKeyUsageInfoEndpoint = m(eps.ReadKeyUsageInfoEndpoint)
	}
	for _, m := range mdw["ReadKeyUsageWithMac"] {
		eps.ReadKeyUsageWithMacEndpoint = m(eps.ReadKeyUsageWithMacEndpoint)
	}
	for _, m := range mdw["ReadKeyUsageBulk"] {
		eps.ReadKeyUsageBulkEndpoint = m(eps.ReadKeyUsageBulkEndpoint)
	}
	for _, m := range mdw["ExpireUsageBulk"] {
		eps.ExpireUsageBulkEndpoint = m(eps.ExpireUsageBulkEndpoint)
	}
	return eps
}
